summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorTony Breeds <tony@bakeyournoodle.com>2016-12-21 13:44:50 +1100
committerChangBo Guo(gcb) <eric.guo@easystack.cn>2017-02-16 14:19:30 +0800
commit30e2cff086cc7a84b0139f2a2e8e93536f5cc3d2 (patch)
tree6f3b7d5e5d1bf205048495a2006d8707544abfad
parentfba2bdbaad2c0ed68a95704cf4a0736a67e70931 (diff)
downloadtaskflow-30e2cff086cc7a84b0139f2a2e8e93536f5cc3d2.tar.gz
Add Constraints support
Adding constraints support to libraries is slightly more complex than services as the libraries themselves are listed in upper-constraints.txt which leads to errors that you can't install a specific version and a constrained version. This change adds constraints support by also adding a helper script to edit the constraints to remove taskflow. (cherry picked from commit 09ded16b22a03c44d907db965d4a376a132b8030) Change-Id: I7dd194beaac22110821270bbca141220f8580182
-rwxr-xr-xtools/tox_install.sh30
-rw-r--r--tox.ini7
2 files changed, 35 insertions, 2 deletions
diff --git a/tools/tox_install.sh b/tools/tox_install.sh
new file mode 100755
index 0000000..e61b63a
--- /dev/null
+++ b/tools/tox_install.sh
@@ -0,0 +1,30 @@
+#!/usr/bin/env bash
+
+# Client constraint file contains this client version pin that is in conflict
+# with installing the client from source. We should remove the version pin in
+# the constraints file before applying it for from-source installation.
+
+CONSTRAINTS_FILE="$1"
+shift 1
+
+set -e
+
+# NOTE(tonyb): Place this in the tox enviroment's log dir so it will get
+# published to logs.openstack.org for easy debugging.
+localfile="$VIRTUAL_ENV/log/upper-constraints.txt"
+
+if [[ "$CONSTRAINTS_FILE" != http* ]]; then
+ CONSTRAINTS_FILE="file://$CONSTRAINTS_FILE"
+fi
+# NOTE(tonyb): need to add curl to bindep.txt if the project supports bindep
+curl "$CONSTRAINTS_FILE" --insecure --progress-bar --output "$localfile"
+
+pip install -c"$localfile" openstack-requirements
+
+# This is the main purpose of the script: Allow local installation of
+# the current repo. It is listed in constraints file and thus any
+# install will be constrained and we need to unconstrain it.
+edit-constraints "$localfile" -- "$CLIENT_NAME"
+
+pip install -c"$localfile" -U "$@"
+exit $?
diff --git a/tox.ini b/tox.ini
index abc05c5..336aafe 100644
--- a/tox.ini
+++ b/tox.ini
@@ -1,5 +1,5 @@
[tox]
-minversion = 1.6
+minversion = 2.0
envlist = cover,
docs,
pep8,
@@ -10,6 +10,10 @@ envlist = cover,
[testenv]
deps = -r{toxinidir}/test-requirements.txt
+setenv = VIRTUAL_ENV={envdir}
+ BRANCH_NAME=stable/mitaka
+ CLIENT_NAME=taskflow
+install_command = {toxinidir}/tools/tox_install.sh {env:UPPER_CONSTRAINTS_FILE:https://git.openstack.org/cgit/openstack/requirements/plain/upper-constraints.txt?h=stable/mitaka} {opts} {packages}
commands = python setup.py testr --slowest --testr-args='{posargs}'
[testenv:docs]
@@ -25,7 +29,6 @@ commands = {toxinidir}/tools/update_states.sh
commands = flake8 {posargs}
[testenv:pylint]
-setenv = VIRTUAL_ENV={envdir}
deps = {[testenv]deps}
pylint==0.26.0
commands = pylint --rcfile=pylintrc taskflow